#include <bits/stdc++.h>

using namespace std;
#define pb push_back
#define ll long long
#define all(x) x.begin(), x.end()
const int N = 1e5 + 1;
int L[N], R[N], t[N], otv[N], sz[N], z[N];
int sum = 1;

int n, q;

void dfs(int v) {
    if (v == 0) {
        return;
    }
    z[v] = sum;
    if (t[v] == -1) {
        otv[v] = sum;
        sum++;
        dfs(L[v]);
        dfs(R[v]);
    } else if (t[v] == 0) {
        dfs(L[v]);
        otv[v] = sum;
        sum++;
        dfs(R[v]);
    } else {
        dfs(L[v]);
        dfs(R[v]);
        otv[v] = sum;
        sum++;
    }
    sz[v] = 1 + sz[L[v]] + sz[R[v]];
}

void dfs2(int v, int h, int k) {
    if (v == 0) {
        return;
    }
    z[v] = h;
    dfs2(L[v], h, k + 1);
    dfs2(R[v], h ^ (1 << k), k + 1);
}

struct triple {
    int l, r, x;
};
int d[N * 4], p[N * 4];

void build3(int v, int l, int r) {
    p[v] = 2;
    if (l == r) {
        d[v] = -1;
        return;
    }
    int m = (l + r) / 2;
    build3(2 * v, l, m);
    build3(2 * v + 1, m + 1, r);
}

void push3(int v) {
    if (p[v] != 2) {
        p[2 * v] = p[v];
        p[2 * v + 1] = p[v];
        d[2 * v] = p[v];
        d[2 * v + 1] = p[v];
        p[v] = 2;
    }
}

void update3(int v, int l, int r, int x, int y, int zn) {
    if (l > y || x > r) {
        return;
    }
    if (l >= x && r <= y) {
        d[v] = zn;
        p[v] = zn;
        return;
    }
    int m = (l + r) / 2;
    push3(v);
    update3(2 * v, l, m, x, y, zn);
    update3(2 * v + 1, m + 1, r, x, y, zn);
}

void find3(int v, int l, int r) {
    if (l == r) {
        t[l] = d[v];
        return;
    }
    int m = (l + r) / 2;
    push3(v);
    find3(2 * v, l, m);
    find3(2 * v + 1, m + 1, r);
}

int find4(int v, int l, int r, int pos) {
    if (l == r) {
        return d[v];
    }
    push3(v);
    int m = (l + r) / 2;
    if (pos > m) {
        return find4(2 * v + 1, m + 1, r, pos);
    }
    return find4(2 * v, l, m, pos);
}

int dfs1(int v, int x, int sum1, int h, int k) {
    if (v == x) {
        int g = find4(1, 1, n, v);
        if (g == 0) {
            sum1 += sz[L[v]];
        } else if (g == 1) {
            sum1 += sz[v] - 1;
        }
        return sum1 + 1;
    }
    if (((h >> k) & 1) == 1) {
        int g = find4(1, 1, n, v);
        if (g == -1 || g == 0) {
            sum1 += sz[v] - sz[R[v]];
        } else {
            sum1 += sz[L[v]];
        }
        return dfs1(R[v], x, sum1, h, k + 1);
    } else {
        int g = find4(1, 1, n, v);
        if (g == -1) {
            sum1++;
        }
        return dfs1(L[v], x, sum1, h, k + 1);
    }
}

void build(int v, int l, int r) {
    p[v] = 0;
    if (l == r) {
        d[v] = l;
        return;
    }
    int m = (l + r) / 2;
    build(2 * v, l, m);
    build(2 * v + 1, m + 1, r);
}

void push(int v) {
    if (p[v] != 0) {
        p[2 * v] += p[v];
        p[2 * v + 1] += p[v];
        d[2 * v] += p[v];
        d[2 * v + 1] += p[v];
        p[v] = 0;
    }
}

void update(int v, int l, int r, int x, int y, int zn) {
    if (l > y || x > r) {
        return;
    }
    if (l >= x && r <= y) {
        d[v] += zn;
        p[v] += zn;
        return;
    }
    push(v);
    int m = (l + r) / 2;
    update(2 * v, l, m, x, y, zn);
    update(2 * v + 1, m + 1, r, x, y, zn);
}

int find_ans(int v, int l, int r, int pos) {
    if (l == r) {
        return d[v];
    }
    int m = (l + r) / 2;
    push(v);
    if (pos > m) {
        return find_ans(2 * v + 1, m + 1, r, pos);
    }
    return find_ans(2 * v, l, m, pos);
}

signed main() {
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
#ifdef LOCAL
    freopen("input.txt", "r", stdin);
    freopen("output.txt", "w", stdout);
#endif
    cin >> n >> q;
    bool was2 = false;
    for (int i = 1; i <= n; ++i) {
        cin >> L[i] >> R[i];
        if (L[i] + R[i] != 0 && (L[i] + R[i] == L[i] || L[i] + R[i] == R[i])) {
            was2 = true;
        }
        t[i] = -1;
    }
    vector<triple> zap(q);
    int kol1 = 0;
    bool was = false, was1 = false;
    int pred = 0;
    for (int i = 0; i < q; ++i) {
        int type;
        cin >> type;
        if (type == 1) {
            int l, r, x;
            cin >> l >> r >> x;
            zap[i] = {l, r, x};
            kol1++;
            if (l != r) {
                was1 = true;
            }
        } else {
            int x;
            cin >> x;
            zap[i] = {0, 0, x};
        }
        if (pred == 2 && type == 1) {
            was = true;
        }
        pred = type;
    }
    if ((n <= 5000 && q <= 5000) || kol1 <= 10) {
        dfs(1);
        for (int i = 0; i < q; ++i) {
            int type;
            if (zap[i].l == 0) {
                type = 2;
            } else {
                type = 1;
            }
            if (type == 1) {
                auto [l, r, x] = zap[i];
                for (int j = l; j <= r; ++j) {
                    t[j] = x;
                }
                sum = 1;
                dfs(1);
            } else {
                int x = zap[i].x;
                cout << otv[x] << "\n";
            }
        }
    } else if (!was) {
        int tek = q;
        build3(1, 1, n);
        for (int i = 0; i < q; ++i) {
            if (zap[i].l == 0) {
                tek = i;
                break;
            }
            auto [l, r, zn] = zap[i];
            update3(1, 1, n, l, r, zn);
        }
        find3(1, 1, n);
        dfs(1);
        for (int i = tek; i < q; ++i) {
            cout << otv[zap[i].x] << "\n";
        }
    } else if (!was1) {
        dfs(1);
        build(1, 1, n);
        for (int i = 0; i < q; ++i) {
            if (zap[i].l == 0) {
                cout << find_ans(1, 1, n, z[zap[i].x]) << "\n";
            } else {
                if (zap[i].x == t[zap[i].l] || sz[zap[i].l] == 1) {
                    continue;
                }
                int v = zap[i].l;
                int e = zap[i].x;
                if (t[v] == -1 && e == 1) {
                    update(1, 1, n, z[v], z[v], sz[v] - 1);
                    update(1, 1, n, z[v] + 1, z[v] + sz[v] - 1, -1);
                } else if (t[v] == -1 && e == 0) {
                    update(1, 1, n, z[v], z[v], sz[L[v]]);
                    update(1, 1, n, z[v] + 1, z[v] + sz[L[v]], -1);
                } else if (t[v] == 0 && e == -1) {
                    update(1, 1, n, z[v], z[v], -sz[L[v]]);
                    update(1, 1, n, z[v] + 1, z[v] + sz[L[v]], 1);
                } else if (t[v] == 0 && e == 1) {
                    update(1, 1, n, z[v], z[v], sz[R[v]]);
                    update(1, 1, n, z[v] + sz[L[v]] + 1, z[v] + sz[v] - 1, -1);
                } else if (t[v] == 1 && e == -1) {
                    update(1, 1, n, z[v], z[v], -sz[v] + 1);
                    update(1, 1, n, z[v] + 1, z[v] + sz[v] - 1, 1);
                } else {
                    update(1, 1, n, z[v], z[v], -sz[R[v]]);
                    update(1, 1, n, z[v] + sz[L[v]] + 1, z[v] + sz[v] - 1, 1);
                }
                t[v] = e;
            }
        }
    } else if(!was2){
        build3(1, 1, n);
        dfs(1);
        dfs2(1, 0, 0);
        for (int i = 0; i < q; ++i) {
            if (zap[i].l != 0) {
                update3(1, 1, n, zap[i].l, zap[i].r, zap[i].x);
            } else {
                cout << dfs1(1, zap[i].x, 0, z[zap[i].x], 0) << "\n";
            }
        }
    }else{
        dfs(1);
        for (int i = 0; i < q; ++i) {
            int type;
            if (zap[i].l == 0) {
                type = 2;
            } else {
                type = 1;
            }
            if (type == 1) {
                auto [l, r, x] = zap[i];
                for (int j = l; j <= r; ++j) {
                    t[j] = x;
                }
                sum = 1;
                dfs(1);
            } else {
                int x = zap[i].x;
                cout << otv[x] << "\n";
            }
        }
    }
    return 0;
}
